[UTF-8]
[Use `iconv -f UTF-8', if needed]

2022-05-31 КриптоПро Android CSP 5.0.42798-fb0531e7 (Java CSP 2.0.42649-0086315f-release-220520-java-csp, CSP 5.0.12500)
* android: библиотека libcspjni экспортирует символы согласно заданному списку (JCP-1967, JCP-1971, JCP-1972, JCP-1973)
* android: библиотека libsupport экспортирует символы согласно заданному списку (JCP-1980)
* android: из ACSPClientApp удалены примеры работы с УЦ 1.5, как устаревшие (JCP-1934)
* android: устранена ошибка с форматированием при отображении окна ввода пароля (JCP-2031)
* android: в ACSP при смене пароля отделенного ключевого носителя новый пароль должен быть непустым (JCP-1946)
* android: улучшен внешний вид окон CSP и ACSP (JCP-1911, JCP-1986, JCP-1556)
* android: убран дубль SharedLibrary.aar/res/raw/config64.ini (JCP-1923)
* android: добавлено подтверждение ввода нового пароля при копировании и смене пароля от контейнера (JCP-1947)
* android: для БиоДСЧ окна CSP размеры компонентов и ячейки, радиус углов ячейки задаются в ресурсах в dp (JCP-1959, JCP-2035)
* android: добавлена возможность скачать или поделиться сертификатом из хранилищ (JCP-1913)
* android: в ACSP существенно доработана панель управления (JCP-1913, JCP-2029)
* android: в ACSP добавлено сообщение об ошибке, если цепочка сертификатов не построена (JCP-1994)
* android: в ACSP добавлены корневые сертификаты тестовых УЦ КриптоПро (JCP-2034)
* android: в ACSP добавлено предупреждение, если в приложение копируется ключевой контейнер с именем, которое уже есть в списке (JCP-2025)
* android: в ACSPClientApp добавлен ввод лицензии (JCP-2019)
* android: в ACSPClientApp в пример установки лицензии добавлена истекшая лицензия, поправлен пример контроля целостности (JCP-2028, JCP-2026)
* revcheck: в Android данные сертификата/CRL при скачивании предварительно помещаются в буфер (JCP-1939)
* revcheck: добавлена возможность использовать строго реализацию алгоритма PKIX провайдера JCPRevCheck вместо стандартного PKIX с помощью параметра disable_default_pkix или RevocationSettings (JCP-1939)
* tls: реализована поддержка лицензии TLS Client в КриптоПро CSP в случае использования Java CSP (NGATE-3117)
* tls: добавлена возможность отключить проверку присутствия сертификата клиентской цепочки в списке издателей с помощью параметра tls_client_disable_issuer_check или JavaTLSCertPathManagerParameters (JCP-1977)
* docs: дополнена документация (JCP-1851)

2022-03-04 КриптоПро Android CSP 5.0.42729-96c5f59d (Java CSP 2.0.42440-8de3cb0c)
* android: targetSdkVersion по умолчанию 31, gradle 7.3+, gradle plugin 7.0+ (JCP-1885)
* android: модули поддержки токенов Rutoken и Jacarta удалены из SDK и могут быть добавлены позднее согласно инструкции https://docs.cryptopro.ru/android/ (JCP-1861)
* android: объединены demo-приложения ACSPClientApp и ACSPInClientApp в одно, оставлен единственный вариант со встроенным провайдером (JCP-1860)
* android: устранена ошибка при переподписывании приложения в формате AAB, когда включен контроль целостности dex-файлов (JCP-1925)
* android: вынесена в local.properties настройка cpverify.path с указанием пути к cpverify для вычисления хэшей, когда включен контроль целостности dex-файлов (JCP-1925)
* android: в примеры examples добавлен тестовый ключ key.jks для подписи APK/AAB (JCP-1918)
* android: добавлены новые корневые сертификаты Минкомсвязи, КриптоПро и др. (JCP-1897, JCP-1882, JCP-1867)
* android: скорректировано отображение серийного номера сертификата (JCP-1891)
* android: улучшена работа с окнами CSP в фоне (JCP-1582)
* android: dexdigests перенесен в JInitCSP.aar (JCP-1763)
* android: в конфиг добавлен логгер fkc, изменилось местоположение некоторых классов (JCP-1768)
* android: сокращено использование SharedPreferences для хранения настроек (JCP-1814)
* android: добавлен javadoc/JInitCSP-javadoc.jar с описанием методов и констант JInitCSP (JCP-1924)
* android: устранена ошибка при копировании папки с ключевым контейнером из памяти устройства (JCP-1940)

2021-11-10 КриптоПро Android CSP 5.0.42576 (Java CSP 2.0.42108-9cdaba1314)
* android: добавлен контроль целостности dex-файлов (JCP-1763)
* android: добавлена поддержка PKCS11 в SDK (JCP-1831)
* android: собственный проводник файлов заменен на стандартный (JCP-1791)
* android: поведение при работе с лицензией при обновлении приложения с CSP 4.0 на CSP 5.0 приближено к CSP для Windows/*nix (JCP-1804)
* android: добавлено автообновление конфига и хранилища корневых сертификатов при обновлении приложения с новым sdk (JCP-1814)
* android: при обновлении конфига выполняется работа с временной копией в целях избежать повреждения исходного файла; убран метод clearCachedKeyStoreTypes из Config, расширены проверки (JCP-1810)
* android: улучшен вид клавиатуры для ввода номера лицензии (JCP-1809)
* android: добавлена проверка расширения файлов сертификатов при загрузке из assets (JCP-1808)
* android: в ACSP устранена ошибка NPE при попытке выпуска тестового сертификата в авиа-режиме (JCP-1796)
* android: из манифестов удалены избыточные инструкции, касающиеся рутокена (JCP-1831)
* android: устранены ошибки локализации на русский язык (JCP-1797, JCP-1826, JCP-1817)
* ngate: делается корректная остановка vpn, когда запущен vpn в другом приложении (JCP-1829)
* ngate: список контейнеров неактивен, если пуст (JCP-1827)
* ngate: добавлена возможность установить цепочку сертификатов из p7b (JCP-1817, JCP-1836)
* ngate: частично поддержана темная тема (JCP-1815)
* ngate: устранена возможность SQL-инъекции в соответствии с рекомендациями от Google (JCP-1803)
* ngate: targetSdk приложения NGateR2 и библиотек NGate_API, SharedLibrary и URIManager теперь равен 30 (JCP-1749)		 		 
* ngate: пакет приложения переименован в "ru.cprocsp.NGateR2", имя приложения изменено на "NGateR2", модуль NGate_API теперь обращается к пакету "ru.cprocsp.NGateR2" приложения "NGateR2" (JCP-1749)
* ngate: восстановление соединения без повторной аутентификации выполняется на протяжении заданного в настройках сервера периода (JCP-1767)
* ngate: добавлена возможность передачи от MDM параметра "maxRetryPeriod" - периода, в течение которого выполняются попытки восстановления соединения без повторной аутентификации при обрыве связи (JCP-1767)
* ngate: при установлении соединения с использованием аутентификации с помощью отделяемого носителя в случае, если последний отсутствует, будет выведено окно с предупреждением (JCP-1769)
* ngate: устранена ошибка при инициализации vpn-сервиса из модуля NGate API (JCP-1749)
* ngate: добавлен вывод в лог заголовков веб-сокета при установлении соединения, даты и времени подключения (JCP-1749)

2021-09-08 КриптоПро Android CSP 5.0.42544 (Java CSP 2.0.42050-f86914188e)
* android: из манифеста JInitCSP.aar удалены intent-filter (JCP-1789)
* android: подсчет хеша установленного apk выполняется в отдельном методе (JCP-1784)
* android: в ACSP в случае ошибки при инициализации провайдера добавлен показ окна с ошибкой перед завершением работы приложения (JCP-1781)
* android: устранена ошибка инициализации лицензии при обновлении с CSP SDK 4.0 на CSP SDK 5.0, добавлена возможность повторно выполнить инициализацию провайдера в случае ошибки (JCP-1779)
* android: устранена ошибка в БиоДСЧ при внезапной отмене в ходе заполнения (JCP-1777)
* android: обновлен модуль поддержки JaCarta, скорректирован конфиг (JCP-1755)
* android: в дистрибутив добавлен новый корневой сертификат Минкомсвязи (CPCSP-12235)
* android: в ACSP добавлен поворот экрана, возможность выпустить тестовый сертификат в тестовом УЦ, цвет предупреждений в окнах цсп подбирается в зависимости от темы, улучшено оформление (JCP-1636)
* android: в ACSPClientApp пример экспорта в PFX запускается в отдельном потоке, а ключ и сертификат берутся из ключевого контейнера, указанного в настройках приложения (JCP-1742)
* tls: устранена ошибка преждевременного удаления ключа в SSL-сессии (JCP-1762)
* tls: исправлена работа TLS в Samsung Android Knox путем уточнения имени провайдера при создании криптографических объектов (JCP-1747)

2021-06-16 КриптоПро Android CSP 5.0.42506 (Java CSP 2.0.41971-4f84201b78)
* android: устранена возникающая в редких случаях при инициализации ошибка NTE_PROV_TYPE_NOT_DEF (JCP-1687)
* android: добавлена поддержка темной темы в android 10+ (JCP-1706)
* android: изменен внешний вид БиоДСЧ (JCP-1706)
* android: расширен конфиг CSP (JCP-1710)
* android: скорректирован список выводимых считывателей в ACSP (JCP-1719)
* android: устранена фантомная ошибка при вводе пароля в окне в armeabi-v7a (JCP-1731)
* android: в ACSP в полях ввода алиаса ключа и пароля запрещен ввод не-ascii символов (JCP-1730, JCP-1698)
* android: обновлен модуль rtserviceconnection (JCP-1712)
* android: улучшена работа в Android 11, targetSdk приложений и JinitCSP теперь равен 30 (JCP-1716, JCP-1714, JCP-1713)
* android: расширена информация об ошибках в окне ввода пароля (JCP-1380, JCP-1697)
* android: улучшена инициализация java-провайдера (JCP-1694)
* android: добавлен вывод уведомления, когда приложение в фоне, о появлении окна CSP для Android 10+ (JCP-1582)
* android: поправлены надписи в окнах CSP, улучшен общий вид (issue #24, JCP-1636)
* android: при удалении приложения его данные удаляются (JCP-1692)
* android: некоторые окна CSP теперь имеют прозрачный фон, переименованы стили внутри приложений (JCP-1681)
* android: устранена невозможность задать пустой пароль к окне ввода пароля CSP после генерации ключа (JCP-1582)
* android: улучшена работа проводника (JCP-1609)
* android: удалены устаревшие проверки версии внутри sdk (JCP-1667)
* android: устранен чрезмерно частый показ окна уведомления об истекшей лицензии (JCP-1582)
* android: задан minSdkVersion = 24, удалена поддержка "Aktiv Rutoken Lite SD 1", как не актуального, добавлен параметр EnableNativeTokenCryptMode для включения "активного" режима на рутокенах (issue #21)
* android: устранен редкий крэш при вводе данных в БиоДСЧ (issue #19)
* android: актуализирована работа БиоДСЧ (JCP-1636)
* android: удалены несколько неактуальных примеров шифрования из ACSPClientApp и поддержка интентов (JCP-1692, JCP-1582)
* ngate: устранена ошибка с сохранением настроек приложения при отключении проверки цепочки сертификатов (JCP-1648)
* ngate: добавлено использование системного хранилища AndroidCAStore в качестве хранилища корневых сертификатов (JCP-1680)
* ngate: улучшен макет окна ввода пароля для PFX (JCP-1653)
* ngate: добавлен вывод уведомления, когда приложение в фоне, о появлении окна CSP для Android 10+ (JCP-1668)
* ngate: при подключении больше не запрашивается пароль, если он не нужен (JCP-1653)
* ngate: реализована поддержка OTP решения от Аладдин Р.Д. (JAS) (JCP-1653)
* jcsp: устранена ошибка работы в режиме strict mode в Android (JCP-1693, CPCSP-12071)
* jcsp: исправлена ошибка, когда CryptContextAddRef мог быть не выполнен (JCP-1689, JCP-1677)
* jcsp: исправлена ошибка в использовании Log.isLoggable, приводящая к крэшу в Samsung с Android 11 (JCP-1678)

2021-02-10 КриптоПро Android CSP 5.0.42409, КриптоПро NGate 1.0.42409

2021-01-27 КриптоПро Android CSP 5.0.42396, КриптоПро NGate 1.0.42396
* android: переработан и упрощен механизм отображения окон CSP в android-приложениях, теперь больше не требуется CSPConfig.registerActivityContext (JCP-1582)
* android: расширены языковые ресурсы (issue #1)
* android: улучшен вид вкладки просмотра сертификатов (JCP-1636)
* android: обновлена экспортная лицензия (issue #24)
* android: в ACSPClientApp расширено описание параметров для инициализации TLS, добавлено свойство disable_default_context=true (issue #9)
* android: в ACSPClientApp добавлено описание возможности отключить проверку цепочки сертификатов при создании подписи формата BES или T (JCP-1643, issue #3)
* ngate: при отключении проверки цепочки сертификатов в настройках также отключается tls_prohibit_disabled_validation (JCP-1648)

2020-11-03 КриптоПро Android CSP 5.0.42324, КриптоПро NGate 1.0.42324
* android: полностью обновлен и существенно улучшен интерфейс ACSP (JCP-1096)
* android: в ACSPClientApp добавлен запрос прав на запись для CMSUtil (JCP-1631)
* android: в ACSP активити установки сертификата устанавливает сертификат подписи в контейнер (JCP-1632)
* android: в ACSPClientApp в примере создания контейнера с помощью интента удален адрес УЦ (JCP-1630)
* android: в активити подписи добавлена возможность передать адрес TSP службы (JCP-1217)
* android: удалены сертификаты тестовых уЦ (JCP-1616)
* android: изменена работа интерфейса обращения с лицензией в SDK (JCP-1610)
* android: новый проводник для выбора файлов и папок (JCP-1609)
* android: исправлены ошибки с вводом и получением серийного номера лицензии (JCP-1581)
* android: панель управления CSP вынесена в отдельную библиотеку CSPNavigationMenu (JCP-1096)
* android: обновлен модуль поддержки токенов Аладдин (JCP-1560)
* android: добавлена поддержка NFC считывателя, Rutoken FKC (3000) считывателя, добавлено окно выбора считывателей и апплетов (JCP-1555)
* android: доработаны примеры, добавлен пример чтения PFX (JCP-1563)
* android: изменены имена логгеров в секции debug конфигурации в соответствии с CSP (JCP-1568)
* android: в окно ввода пароля добавлены подсказка, фокусирование на поле ввода и вывод клавиатуры (JCP-1562)
* android: устранена ошибка при вводе неправильного пароля в англоязычной локализации (JCP-174)
* android: SDK для встраивания вынесен в SharedLibrary.aar (JCP-1368)
* android: добавлен модуль поддержки Аладдин токенов JaCarta (CPCSP-10850)
* android: сборка demo-приложений выполняется gradle, расширена документация (JCP-1368)
* android: исправлена ошибка в определении высоты окна ДСЧ (JCP-1433)
* android: добавлено отображение ошибки в случае несоответствия вводимого в окне запроса пароля требуемому формату (JCP-1380) 
* android: расширен список корневых сертификатов (JCP-174)
* android: добавлена возможность задать свой config при использовании SDK с помощью класса CustomConfig (JCP-1461)
* android: обновлен уровень логирования в секции debug конфига (JCP-174)
* android: обновлен конфиг (JCP-1420, JCP-1178)
* android: расширена документация (JCP-1475)
* android: сборка с android gradle plugin 3.6.0+ должна выполняться с android:extractNativeLibs="true" в манифесте (JCP-1439)
* android: файлы хешей библиотек для контроля целостности перенесены в SharedLibrary.aar (JCP-1518)
* android: удалены файлы неиспользуемых библиотек libpcsclite (JCP-1521)
* android: удален dsrf, как излишний (JCP-1495)
* android: добавлен таймаут для более редкого отображения сообщения об истекшей лицензии CSP (JCP-1523)
* ngate: устранено зависание приложения при работе в окне ввода пароля при истекшей лицензии (JCP-1611)
* ngate: добавлена возможность применить лицензию и продолжить работу без перезапуска приложения (NGATE-2680)
* ngate: изменены ссылки в описании программы (NGATE-2682)
* ngate: пакет приложения переименован в ru.cprocsp.NGate (JCP-1472)
* ngate: добавлен импорт PFX, лицензии, профиля, сертификатов и CRL из QR-кода, добавлена документация (JCP-1188)
* ngate: улучшена поддержка Samsung в защищенном режиме Knox (JCP-1422)
* ngate: добавлена возможность интеграции с MDM, поддержка restrictions, добавлена документация (JCP-1385, JCP-1574)
* ngate: улучшена поддержка android 9+, расширена документация (JCP-1340)
* ngate: добавлен VPN API для управления VPN, добавлена документация (JCP-1386)
* ngate: добавлен показ сертификатов в ключевом контейнере во вкладке "Контейнеры приложения" (JCP-1188)
* ngate: после ребута устройства выполняется восстановление VPN-соединения, если перед ребутом VPN-соединение было установлено (JCP-1386)
* ngate: поддержан режим "Постоянный VPN" (JCP-1444)
* ngate: в android 10 и выше после ребута устройства пароль для аутентификации, если не был сохранен, запрашивается в уведомлении (JIRA: JCP-1386)
* ngate: в android 8 и выше добавлено уведомление о состоянии работы VPN службы (JCP-1340)
* ngate: обновлены иконки (JCP-1500)
* jcp: обновлена версия зависимости bouncycastle с 1.50 до 1.60, json с 20080701 до 20180813, commons-logging с 1.1.1 до 1.2 (JCP-1566)
* jcp: добавлена обработка критического расширения 1.3.6.1.4.1.311.20.2 (OID_ENROLL_CERTTYPE_EXTENSION) в сертификате (JCP-1520)
* jcp: из JCPRequest удалена реализация http-подключения с помощью apache http client (JCP-1340)
* jcp: обновлены классы модулей JCPRevCheck, JCPRevTools, исправлена ошибка декодирования сертификата (JCP-1466)
* jcsp: добавлена генерация секретного ключа на алгоритме DES (JCP-1585)
* jcsp: теперь секретные ключи на алгоритме AES, 3DES, DES по умолчанию генерируются в памяти (JCP-1585)
* jcsp: добавлена возможность ускорить проверку подписи с помощью -Duse_public_key_fast=true (JCP-1621)
* jcsp: улучшено копирование ключевых контейнеров (JCP-1585)
* jcsp: добавлен экспорт/импорт секретного ключа с алгоритмом AES, 3DES, DES на ключе RSA, добавлен пример (JCP-1584)
* jcsp: добавлен экспорт/импорт секретного ключа с алгоритмом AES, 3DES, DES на аналогичном секретном ключе, добавлен пример (JCP-1607)
* jcsp: если секретный ключ создается или копируется в существующий контейнер, то генерируется ошибка, перезапись запрещена (JCP-1606) 
* jcsp: добавлена поддержка NoPadding для иностранных секретных ключей (JCP-1603)
* jcsp: ключи теперь реализуют интерфейс Destroyable (JCP-1462)
* jcsp: DiversKeySpec теперь расширяет SecretKey (JCP-560)
* jcsp: уточнены реализации алгоритмов в провайдерах JCSP и JCSPRSA (JCP-872)
* jcsp: убрано клонирование master-ключа при использовании в TLS (JCP-1397)
* jcsp: добавлена возможность получить исключение WrongPasswordException в случае неправильного пароля PFX для CSP 5.0.11729 и выше (JCP-1443)
* tls: устранена ошибка неправильной передачи distinguished names в случае превышения размера списка 64Кб (JCP-1579)
* tls: расширен список функций инициализации защищенного контекста в TLSContext (JCP-1552)
* tls: версия OkHttp в примерах увеличена до 4.8 (JCP-1554)
* tls: добавлена возможность при проверке цепочки сертификатов использовать CRL, переданный в TrustManager (JCP-1516)
* tls: улучшена передача исключений при подборе ключевого контейнера в KeyManager (JCP-1522)
* tls: устранено требование серверной лицензии TLS при использовании SSLEngine в режиме клиента (JCP-1547)
* tls: алгоритм проверки соответствия хоста и сертификата сервера на клиенте выведен из-под зависимости от tls_prohibit_disabled_validation (JCP-1467)
* tls: добавлена поддержка TLS_CIPHER_2012_IANA (JCP-1326)
* tls: расширен список "белых функций" инициализации TLS с помощью класса TLSContext (JCP-1425)
* tls: упрощен код создания cipher suite в cpSSL и определение размера IV (JCP-1601)
* tls: удаление хендла ключа перемещено в кэш сессий (JCP-1116)
* tls: исправлена ошибка при определении значения параметра tls_prohibit_disabled_validation (JCP-1390)
* tls: клиент больше не отправляет расширение TLSGostExtensionHashHMACSelect в ClientHello, клиент и сервер проверяют расширение
       только в случае использования TLS_CIPHER_2001 (JCP-1424)
* tls: в экспериментальном режиме в TLS v.1.2 добавлена поддержка cipher suites с использованием алгоритмов Кузнечик/Магма (JCP-1397)
* tls: теперь используется модуль cpSSL вместо cpSSL-android, пакет ru.CryptoPro.ssl (JCP-1429)
* tls: apache http client обновлен с версии 4 до client5 (JCP-1340)
* cades: устранена ошибка непреднамеренного кеширования хеша подписантом (JCP-1594)
* cades: доработана процедура формирования и проверки подписи формата CAdES-A:
         при усовершенствовании, если последний неусовершенствованный архивный штамп, он усовершенствуется,
         при внутренней проверке усовершенствованного архивного штампа на момент самого штампа принимаются доказательства из будущего,
         при проверке последнего усовершенствованного архивного штампа цепочка его подчиненного УЦ проверяется на текущий момент,
         при проверке, если последний архивный штамп - неусовершенствованный, то он проверяется на текущий момент (JCP-1544)
* cades: устранена ошибка 405 при скачивании CRL (JCP-1573)
* cades: теперь при формировании OCSP запроса алгоритм хеширования определяется по алгоритму ключа сертификата.
         По умолчанию алгоритм хеширования в TSP запросе определяется по алгоритму ключа сертификата подписи.
         Добавлена более точная передача имени провайдера (JCP-1580)
* cades: устранена ошибка удаления ранних архивных штампов в CAdES-A (JCP-1544)
* cades: добавлена поддержка атрибута ats-hash-index-V3, теперь он используется по умолчанию при создании архивной подписи CAdES-A (JCP-1508, JCP-1513)
* cades: сделан ряд исправлений в формате архивной подписи CAdES-A в соответствии с рекомендациями стандарта CAdES (JCP-1509, JCP-1510, JCP-1511, JCP-1512)
* cades: ряд изменений в алгоритме добавления и проверки архивных штампов: архивный штамп добавляется сразу усовершенствованным,
         проверка усовершенствованного штампа выполняется на момент самого штампа. Добавление нового архивного штампа возвращает
         ошибку если предыдущий штамп не имеет доказательств. (JCP-1524)
* cades: OID алгоритма ключа в CAdES подписи всегда алгоритм ключа подписи (JCP-1383)
* cades: в EnvelopedSignature устранена ошибка добавления пустых unprotected-атрибутов (CPCSP-10847)
* xades: при поиске сертификатов перед проверкой X Long Type 1 дополнительно используются сертификаты из KeyInfo (CADES-2087)